EQTY LabDocs

Update plugin definition

Changes the supplied fields of a definition, such as pointing it at a new artifact or retiring it. Admin only; API keys are refused.

patchhttps://<host>/api/v1/plugins/definitions/{definitionId}
bash
curl --request PATCH \
  --url 'https://<host>/api/v1/plugins/definitions/{definitionId}' \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '{"artifact_id":0,"config_schema_json":{},"default_mode":"enforcement","required_capabilities":["cid.resolve"],"runtime":"premade","status":"active","supported_hooks":["request.start"]}'
javascript
const response = await fetch("https://<host>/api/v1/plugins/definitions/{definitionId}", {
  method: "PATCH",
  headers: {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
  },
  body: JSON.stringify({
    "artifact_id": 0,
    "config_schema_json": {},
    "default_mode": "enforcement",
    "required_capabilities": [
      "cid.resolve"
    ],
    "runtime": "premade",
    "status": "active",
    "supported_hooks": [
      "request.start"
    ]
  })
});

const data = await response.json();
typescript
interface DefinitionResponse {
  correlation_id?: string;
  item?: Record<string, unknown>;
}

const response = await fetch("https://<host>/api/v1/plugins/definitions/{definitionId}", {
  method: "PATCH",
  headers: {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
  },
  body: JSON.stringify({
    "artifact_id": 0,
    "config_schema_json": {},
    "default_mode": "enforcement",
    "required_capabilities": [
      "cid.resolve"
    ],
    "runtime": "premade",
    "status": "active",
    "supported_hooks": [
      "request.start"
    ]
  })
});
if (!response.ok) throw new Error(`${response.status} ${response.statusText}`);

const data: DefinitionResponse = await response.json();
python
import requests

response = requests.patch(
    "https://<host>/api/v1/plugins/definitions/{definitionId}",
    headers={
        "Authorization": "Bearer <token>",
        "Content-Type": "application/json",
    },
    json={
        "artifact_id": 0,
        "config_schema_json": {},
        "default_mode": "enforcement",
        "required_capabilities": [
            "cid.resolve",
        ],
        "runtime": "premade",
        "status": "active",
        "supported_hooks": [
            "request.start",
        ],
    },
)
response.raise_for_status()
print(response.json())
go
package main

import (
	"fmt"
	"io"
	"net/http"
	"strings"
)

func main() {
	body := strings.NewReader(`{
	  "artifact_id": 0,
	  "config_schema_json": {},
	  "default_mode": "enforcement",
	  "required_capabilities": [
	    "cid.resolve"
	  ],
	  "runtime": "premade",
	  "status": "active",
	  "supported_hooks": [
	    "request.start"
	  ]
	}`)
	req, err := http.NewRequest(http.MethodPatch, "https://<host>/api/v1/plugins/definitions/{definitionId}", body)
	if err != nil {
		panic(err)
	}
	req.Header.Set("Authorization", "Bearer <token>")
	req.Header.Set("Content-Type", "application/json")

	res, err := http.DefaultClient.Do(req)
	if err != nil {
		panic(err)
	}
	defer res.Body.Close()

	data, err := io.ReadAll(res.Body)
	if err != nil {
		panic(err)
	}
	fmt.Println(res.Status, string(data))
}
java
import java.net.URI;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;

public class Example {
    public static void main(String[] args) throws Exception {
        HttpRequest request = HttpRequest.newBuilder()
            .uri(URI.create("https://<host>/api/v1/plugins/definitions/{definitionId}"))
            .header("Authorization", "Bearer <token>")
            .header("Content-Type", "application/json")
            .method("PATCH", HttpRequest.BodyPublishers.ofString("""
                {
                  "artifact_id": 0,
                  "config_schema_json": {},
                  "default_mode": "enforcement",
                  "required_capabilities": [
                    "cid.resolve"
                  ],
                  "runtime": "premade",
                  "status": "active",
                  "supported_hooks": [
                    "request.start"
                  ]
                }
                """))
            .build();

        HttpResponse<String> response = HttpClient.newHttpClient()
            .send(request, HttpResponse.BodyHandlers.ofString());
        System.out.println(response.statusCode() + " " + response.body());
    }
}
csharp
using System.Net.Http.Headers;
using System.Text;

using var client = new HttpClient();
using var request = new HttpRequestMessage(HttpMethod.Patch, "https://<host>/api/v1/plugins/definitions/{definitionId}");
request.Headers.Authorization = new AuthenticationHeaderValue("Bearer", "<token>");
request.Content = new StringContent("""
    {
      "artifact_id": 0,
      "config_schema_json": {},
      "default_mode": "enforcement",
      "required_capabilities": [
        "cid.resolve"
      ],
      "runtime": "premade",
      "status": "active",
      "supported_hooks": [
        "request.start"
      ]
    }
    """, Encoding.UTF8, "application/json");

using var response = await client.SendAsync(request);
Console.WriteLine($"{(int)response.StatusCode} {await response.Content.ReadAsStringAsync()}");
php
<?php

$ch = curl_init('https://<host>/api/v1/plugins/definitions/{definitionId}');
curl_setopt_array($ch, [
    CURLOPT_CUSTOMREQUEST => 'PATCH',
    CURLOPT_HTTPHEADER => [
        'Authorization: Bearer <token>',
        'Content-Type: application/json',
    ],
    CURLOPT_POSTFIELDS => <<<'JSON'
    {
      "artifact_id": 0,
      "config_schema_json": {},
      "default_mode": "enforcement",
      "required_capabilities": [
        "cid.resolve"
      ],
      "runtime": "premade",
      "status": "active",
      "supported_hooks": [
        "request.start"
      ]
    }
    JSON,
    CURLOPT_RETURNTRANSFER => true,
]);

$response = curl_exec($ch);
$status = curl_getinfo($ch, CURLINFO_RESPONSE_CODE);
echo $status . " " . $response . PHP_EOL;
ruby
require "net/http"

uri = URI("https://<host>/api/v1/plugins/definitions/{definitionId}")
request = Net::HTTP::Patch.new(uri)
request["Authorization"] = "Bearer <token>"
request["Content-Type"] = "application/json"
request.body = <<~'JSON'
  {
    "artifact_id": 0,
    "config_schema_json": {},
    "default_mode": "enforcement",
    "required_capabilities": [
      "cid.resolve"
    ],
    "runtime": "premade",
    "status": "active",
    "supported_hooks": [
      "request.start"
    ]
  }
JSON

response = Net::HTTP.start(uri.hostname, uri.port, use_ssl: uri.scheme == "https") do |http|
  http.request(request)
end
puts "#{response.code} #{response.body}"
rust
// Cargo.toml dependencies: reqwest (features "json"), serde_json, tokio (features "full")
use serde_json::json;

#[tokio::main]
async fn main() -> Result<(), Box<dyn std::error::Error>> {
    let response = reqwest::Client::new()
        .patch("https://<host>/api/v1/plugins/definitions/{definitionId}")
        .header("Authorization", "Bearer <token>")
        .json(&json!({
            "artifact_id": 0,
            "config_schema_json": {},
            "default_mode": "enforcement",
            "required_capabilities": [
                "cid.resolve"
            ],
            "runtime": "premade",
            "status": "active",
            "supported_hooks": [
                "request.start"
            ]
        }))
        .send()
        .await?;

    println!("{} {}", response.status(), response.text().await?);
    Ok(())
}

Authorizations

  • BearerAuth · API key in header "Authorization" — Type "Bearer" followed by a space and a sign-in token: a Guardian Platform JWT, or an OIDC ID token in a standalone deployment.

Parameters

Path parameters

NameTypeDescription
definitionId
required
integer

Definition ID

Request bodyrequired

Fields to change

application/json
  • artifact_idinteger
  • config_schema_jsonobject
  • default_modeplugins.PluginMode

    One ofenforcementobservability

  • required_capabilitiesplugins.CapabilityName[]
  • runtimeplugins.PluginRuntime

    One ofpremadewasm

  • statusplugins.DefinitionStatus

    One ofactivedisabled

  • supported_hooksplugins.HookName[]
Examplejson
{
  "artifact_id": 0,
  "config_schema_json": {},
  "default_mode": "enforcement",
  "required_capabilities": [
    "cid.resolve"
  ],
  "runtime": "premade",
  "status": "active",
  "supported_hooks": [
    "request.start"
  ]
}

Responses

200OK

application/json
  • correlation_idstring
  • itemplugins.PluginDefinition
    Show plugins.PluginDefinition
    • artifact_idinteger
    • config_schema_jsonobject
    • created_atstring
    • default_modeplugins.PluginMode

      One ofenforcementobservability

    • idinteger
    • plugin_idstring
    • required_capabilitiesplugins.CapabilityName[]
    • runtimeplugins.PluginRuntime

      One ofpremadewasm

    • statusplugins.DefinitionStatus

      One ofactivedisabled

    • supported_hooksplugins.HookName[]
Examplejson
{
  "correlation_id": "string",
  "item": {
    "artifact_id": 0,
    "config_schema_json": {},
    "created_at": "string",
    "default_mode": "enforcement",
    "id": 0,
    "plugin_id": "string",
    "required_capabilities": [
      "cid.resolve"
    ],
    "runtime": "premade",
    "status": "active",
    "supported_hooks": [
      "request.start"
    ]
  }
}

400Bad Request

application/json
  • codestring
  • correlation_idstring
  • messagestring
Examplejson
{
  "code": "string",
  "correlation_id": "string",
  "message": "string"
}

401Unauthorized

application/json
  • codestring
  • correlation_idstring
  • messagestring
Examplejson
{
  "code": "string",
  "correlation_id": "string",
  "message": "string"
}

403Forbidden

application/json
  • codestring
  • correlation_idstring
  • messagestring
Examplejson
{
  "code": "string",
  "correlation_id": "string",
  "message": "string"
}

404Not Found

application/json
  • codestring
  • correlation_idstring
  • messagestring
Examplejson
{
  "code": "string",
  "correlation_id": "string",
  "message": "string"
}

500Internal Server Error

application/json
  • codestring
  • correlation_idstring
  • messagestring
Examplejson
{
  "code": "string",
  "correlation_id": "string",
  "message": "string"
}

503Plugin store not configured

application/json
  • codestring
  • correlation_idstring
  • messagestring
Examplejson
{
  "code": "string",
  "correlation_id": "string",
  "message": "string"
}